(defun Parsegets ( / s1 l1 me mb lt ns ) ;      
	(setq s1 nil) ;   (: D18400C)
	(setq l1 nil) ;    (8)
	(setq me nil) ;      (7)
	(setq mb nil) ;      (5)
	(setq lt nil) ;      
;--------------------------------------------------------------------------
	(setq ng nil) ;        ("400")
	(setq ngi nil);        (400)
	(setq nb nil) ;  (D18A)
	(setq ne nil) ;  (C)
;----------------------------------------------------------------------------
	(setq ns nil) ; ,    
	;     , 
	;	ng   ,
	;    ngi ,   0
	(setq s1 (getstring nil " : ")) ;   ( )
	(if (= s1 "")
		(setq s1 "1") ;    ,  ,   "1"
	)
	(setq l1 (strlen s1)) ;   
	(while (and (/= 0 l1) (null me)) ;      
		(setq lt (substr s1 l1 1)) ;   
		(if (and (>= (ascii lt) 48)	(<= (ascii lt) 57)) ;   ?
			(setq me l1) ; ,  ,     
		)
		(setq l1 (1- l1)) ; ,  ,     
	)
	(while (and (/= 0 l1) (null mb)) ;       
		(setq lt (substr s1 l1 1)) ;   
		(if (or (< (ascii lt) 48) (> (ascii lt) 57)) ;    ?
			(setq mb (1+ l1)) ; ,   ,     
		)
		(setq l1 (1- l1)) ; ,  ,   
	)
	(if (null mb) (setq mb 1)) ;     ,     1
	(if (null me) (setq me (strlen s1))) ;         
	                                     ;  
	(setq ng (substr s1 mb (1+ (- me mb)))) ;     
	                                        ;   1   
											;   
	(setq ngi (atoi ng)) ;     
	(setq nb (substr s1 1 (1- mb))) ;  
	(setq ne (substr s1 (1+ me))) ;  
	(setq ns (strcat nb ng ne)) ;     
)

(defun Makenabor ( / nnabor tnabor)
; makenabor -            
; nnabor -  
;---------------------------------------------------------------------------------
; nabor -    
;
	(setq nabor nil nnabor nil tnabor nil)
;	
	(setq nabor (ssget)) ;     
	(setq nnabor (sslength nabor)) ;  
	(setq tnabor nnabor)
	
	(while (/= 0 nnabor) ;    
		(setq nnabor (1- nnabor))
		(if (/= "INSERT" (cdr (assoc 0 (entget (ssname nabor nnabor)))))
			(progn
			(ssdel (ssname nabor nnabor) nabor)
			)
		)
	)
	(if (> (sslength nabor) 1000)
			(alert (strcat "  " (itoa tnabor) " \n"
			"  " (itoa (sslength nabor)) "\n" 
			(itoa (- tnabor (sslength nabor))) "   \n" "  "))
	)
)
(defun nnabor ( / i5 ap )
; nnabor -          
; i5 -   
; ap -     
; ---------------------------------------------------------------------
; tp -      
;
	(setq	i5 (sslength nabor) tp nil) 
	(while (/= 0 i5)
		(setq ap (entget (ssname nabor (setq i5 (1- i5)))))
		(setq tp (append tp (list ap)))
	)
)

;;;     
(defun remcondupes ( l / r )
  (setq r nil)
  (while l
     (if (not (= (fix (car l))
		 (if (cadr l) (fix (cadr l))
		   0 ); if
		 ); =
	      ); not
         (setq r (cons (car l) r))
      );if
     (setq l (cdr l))
     (reverse r)
    ); while
  ); remcondupes
	    

(defun Y-Max ( / p) ;   y-  
;                              
; tp -       (0 . INSERT)
; ------------------------------------------------------------------
; tpy -  y-  
;                              
	(setq tpy nil)             
	(foreach p tp              
		(setq tpy              
			(append tpy
				(list (caddr (assoc 10 p)))
			)
		)
	)
	(setq tpy (vl-sort tpy '>));     9 8 7 6 5....
        (setq tpy (remcondupes tpy)) ;  
); defun Y-Max

(defun Y-Min ( / p) ;   y-  
;                              
; tp -       (0 . INSERT)
; ------------------------------------------------------------------
; tpy -  y-  
;                              
	(setq tpy nil)             
	(foreach p tp              
		(setq tpy              
			(append tpy
				(list (caddr (assoc 10 p)))
			)
		)
	)
	(setq tpy (vl-sort tpy '<)) ;     5 6 7 8 9....
       (setq tpy (remcondupes tpy)) ;  

); defun Y-Min

(defun X-Max ( / p) ;   x-  
;                              
; tp -       (0 . INSERT)
; ------------------------------------------------------------------
; tpx -  x-  
;                              
	(setq tpx nil)             
	(foreach p tp              
		(setq tpx              
			(append tpx
				(list (cadr (assoc 10 p)))
			)
		)
	)
	(setq tpx (vl-sort tpx '>)) ;     9 8 7 6 5....
       (setq tpx (remcondupes tpx)) ;  
); defun X-Max

(defun X-Min ( / p) ;   x-  
;                              
; tp -       (0 . INSERT)
; ------------------------------------------------------------------
; tpx -  x-  
;                              
	(setq tpx nil)             
	(foreach p tp              
		(setq tpx              
			(append tpx
				(list (cadr (assoc 10 p)))
			)
		)
	)
	(setq tpx (vl-sort tpx '<)) ;     5 6 7 8 9....
       (setq tpx (remcondupes tpx)) ;  
) ; defun X-Min

(defun X-Sort ( next_y_from_tpy / x101 x102) ;     
; 321
; 
; next_y_from_tpy - y- ,    tpy
;  tp -       (0 . INSERT)
; tpy -   y-
;--------------------------------------------------------------------
; tpsorting -        
;
	(setq tpsorting nil)
	(foreach p tp
		(if (= (fix (caddr (assoc 10 p))) (fix next_y_from_tpy))
				(setq tpsorting (append tpsorting (list p)))   ;  
		)
	)
	(setq tpsorting
		(vl-sort tpsorting 
			(function 
				(lambda (x101 x102)
					(> (cadr (assoc 10 x101)) ;   X
						(cadr (assoc 10 x102)) ;   X  
					); >
				); lambda
			); function
			
		); vl-sort
	); setq tpsorting
); defun X-Sort

(defun X+Sort ( next_y_from_tpy / x101 x102) ;     
; 123
; 
; next_y_from_tpy - y- ,    tpy
;  tp -       (0 . INSERT)
; tpy -   y-
;--------------------------------------------------------------------
; tpsorting -        
;
	(setq tpsorting nil)
	(foreach p tp
		(if (= (fix (caddr (assoc 10 p))) (fix next_y_from_tpy))
				(setq tpsorting (append tpsorting (list p)))   ;  
		)
	)
	(setq tpsorting
		(vl-sort tpsorting 
			(function 
				(lambda (x101 x102)
					(< (cadr (assoc 10 x101)) ;   X
						(cadr (assoc 10 x102)) ;   X  
					); <
				); lambda
			); function
			
		); vl-sort
	); setq tpsortig
); defun X+Sort

(defun Y+Sort ( next_x_from_tpx / y101 y102) ;     
; 1
; 2
; 3
; next_x_from_tpx - x- ,    tpx
;  tp -       (0 . INSERT)
; tpx -   x-
;--------------------------------------------------------------------
; tpsorting -        
;
	(setq tpsorting nil)
	(foreach p tp
		(if (= (fix (cadr (assoc 10 p))) (fix next_x_from_tpx))
;			(progn
				; (princ (cadr (assoc 10 p)))
				; (princ)
				; (print next_x_from_tpx)
				(setq tpsorting (append tpsorting (list p)))   ;  
;			)
		)
	)
;	(print tpsorting)
	(setq tpsorting
		(vl-sort tpsorting 
			(function 
				(lambda (y101 y102)
					(> (caddr (assoc 10 y101)) ;   Y
						(caddr (assoc 10 y102)) ;   Y  
					); >
				); lambda
			); function
		); vl-sort
	); setq tpsorting
); defun Y+Sort

(defun Y-Sort ( next_x_from_tpx / y101 y102) ;     
; 3
; 2
; 1
; next_x_from_tpx - x- ,    tpx
;  tp -       (0 . INSERT)
; tpx -   x-
;--------------------------------------------------------------------
; tpsorting -        
;
	(setq tpsorting nil)
	(foreach p tp
		(if (= (fix (cadr (assoc 10 p))) (fix next_x_from_tpx))
				(setq tpsorting (append tpsorting (list p)))   ;  
		)
	)
	(setq tpsorting
		(vl-sort tpsorting 
			(function 
				(lambda (y101 y102)
					(< (caddr (assoc 10 y101)) ;   Y
						(caddr (assoc 10 y102)) ;   Y  
					); <
				); lambda
			); function
		); vl-sort
	); setq tpsorting
); defun Y-Sort

(defun Makesort1 ( / )
	(Y-Max) ;     tpy 
			;       
	(setq tpsort nil)
	(foreach y tpy
		(X+Sort y)	;      "y"
					;    "x"
		(foreach fp tpsorting
			(setq tpsort (append tpsort (list fp))) ; tpsort  ,
													;     "x"
													;     "y"
													; 123   ^ y
													; 456   |
													; 789   |
													;       +-----> x
		); foreach
	); foreach
); defun Makesort1

(defun Makesort2 ( / )
	(Y-Max) ;     tpy 
			;       
	(setq tpsort nil)
	(foreach y tpy
		(X-Sort y)	;      "y"
					;    "x"
		(foreach fp tpsorting
			(setq tpsort (append tpsort (list fp))) ; tpsort  ,
													;     "x"
													;     "y"
													; 321   ^ y
													; 654   |
													; 987   |
													;       +-----> x
		); foreach
	); foreach
); defun Makesort2

(defun Makesort3 ( / )
	(Y-Min) ;     tpy 
			;       
	(setq tpsort nil)
	(foreach y tpy
		(X-Sort y)	;      "y"
					;    "x"
		(foreach fp tpsorting
			(setq tpsort (append tpsort (list fp))) ; tpsort  ,
													;     "x"
													;     "y"
													; 987   ^ y
													; 654   |
													; 321   |
													;       +-----> x
		); foreach
	); foreach
); defun Makesort3

(defun Makesort4 ( / )
	(Y-Min) ;     tpy 
			;       
	(setq tpsort nil)
	(foreach y tpy
		(X+Sort y)	;      "y"
					;    "x"
		(foreach fp tpsorting
			(setq tpsort (append tpsort (list fp))) ; tpsort  ,
													;     "x"
													;     "y"
													; 789   ^ y
													; 456   |
													; 123   |
													;       +-----> x
		); foreach
	); foreach
); defun Makesort4

(defun Makesort5 ( / )
	(X-Min) ;     tpx 
			;       
	(setq tpsort nil)
	(foreach x tpx
		(Y+Sort x)	;      "x"
					;    "y"
		(foreach fp tpsorting
			(setq tpsort (append tpsort (list fp))) ; tpsort  ,
													;     "y"
													;     "x"
													; 147   ^ y
													; 258   |
													; 369   |
													;       +-----> x
		); foreach
	); foreach

 ); defun Makesort5

(defun Makesort6 ( / )
	(X-Min) ;     tpx 
			;       
	(setq tpsort nil)
	(foreach x tpx
		(Y-Sort x)	;      "x"
					;    "y"
		(foreach fp tpsorting
			(setq tpsort (append tpsort (list fp))) ; tpsort  ,
													;     "y"
													;     "x"
													; 369   ^ y
													; 258   |
													; 147   |
													;       +-----> x
		); foreach
	); foreach
); defun Makesort6

(defun Makesort7 ( / )
	(X-Max) ;     tpx 
			;       
	(setq tpsort nil)
	(foreach x tpx
		(Y+Sort x)	;      "x"
					;    "y"
		(foreach fp tpsorting
			(setq tpsort (append tpsort (list fp))) ; tpsort  ,
													;     "y"
													;     "x"
													; 741   ^ y
													; 852   |
													; 963   |
													;       +-----> x
		); foreach
	); foreach
); defun Makesort7

(defun Makesort8 ( / )
	(X-Max) ;     tpx 
			;       
	(setq tpsort nil)
	(foreach x tpx
		(Y-Sort x)	;      "x"
					;    "y"
		(foreach fp tpsorting
			(setq tpsort (append tpsort (list fp))) ; tpsort  ,
													;     "y"
													;     "x"
													; 963   ^ y
													; 852   |
													; 741   |
													;       +-----> x
		); foreach
	); foreach
); defun Makesort8

(defun Makenum ( / i5 mpin mpat nn tnn ) ;         
;
; nb -   , 
; ng -         ,    
; ngi - ,     ,  
; ne -   , 
;------------------------------------------------------------
; tpsort -   
; i5 -  
; mpin -      (INSERT)
; mpat -       tnn)
; nn -     (1 . nn)   
; nni -      ,   parsegets
; nnt -       ,   parsegets 
; tnn -      (1 . tnn)
; 
	(setq i5 (length tpsort))
	(while (/= 0 i5 )
		(setq mpin (cdr (assoc -1  (nth (setq i5 (1- i5)) tpsort)))) ;    insert ()
		(setq mpat (entget (entnext mpin))) ;   attrib  insert
		(setq nn (assoc 1 mpat)) ;      (1 . nn)
		(if (/= 0 ngi)
			(progn
			(setq nni (+ ngi i5)) ;     ,   parsegets
			(setq nnt (strcat nb (itoa nni) ne)) ;       ,   parsegets
			); progn
			(setq nnt ng) ;   ,    
		); if
		(setq tnn (cons 1 nnt)) ;     (1 . nb+ngi+i5+ne)
		(setq mpat (subst tnn nn mpat)) ;      
		(entupd (cdr (assoc -1 (entmod mpat)))) ;     
	); while
(princ)
(if (> (sslength nabor) 1000)
	(alert " ")
); if
); defun Makenum

(defun c:annu ( / errorpos nb ne ng ngi tp tpx tpy tpsort tpsorting nabor nnt nni)
;;;(defun c:annu (/)
(Parsegets) ;   
(Makenabor) ;       
(Nnabor) ;     
(cond ;  
	((= (getvar "USERI1") 1) (makesort1)) ; Y1>Y2 X1<X2 
	((= (getvar "USERI1") 2) (makesort2)) ; Y1>Y2 X1>X2 
	((= (getvar "USERI1") 3) (makesort3)) ; Y1<Y2 X1>X2 
	((= (getvar "USERI1") 4) (makesort4)) ; Y1<Y2 X1<X2 
	((= (getvar "USERI1") 5) (makesort5)) ; X1<X2 Y1>Y2
	((= (getvar "USERI1") 6) (makesort6)) ; X1<X2 Y1<Y2
	((= (getvar "USERI1") 7) (makesort7)) ; X1>X2 Y1>Y2
	((= (getvar "USERI1") 8) (makesort8)) ; X1>X2 Y1<Y2
	(T (makesort4)) 
)
(Makenum) ;   (    
;	         )
);defun c:annu
;
; 
;  c:annu    
;   (      
;  ).
;       
;     (  
;  ,        -  
;  ,          1,
;    ,     1)
;       .
;       "ANNU".
;       
;    ,  ,   
;  .     
;      
;  .      
;    .      
; ,    ,   
;    . ( selectsimilar - 
; )
;    ,   
;    USERI1:
; ,   9- ,   
; 
; 1: 123    2: 321  3: 987  4: 789  5: 147  6: 369  7: 741  8: 963
;    456       654     654     456     258     258     852     852
;    789       987     321     123     369     147     963     741
;   ( USERI1=0)    .
;   20000    2,5  ( i7-4770)
;   4500  -  20 .
;      NanoCADa  5.1  11
;  AutoCAD    .
; - 2019
;